package jp.example;

import static jp.example.CloseableResponse.of;
import static org.junit.Assert.assertEquals;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Invocation.Builder;
import javax.ws.rs.client.WebTarget;

import org.jboss.resteasy.test.BaseResourceTest;
import org.jboss.resteasy.test.TestPortProvider;
import org.junit.After;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class ExampleResourceTest extends BaseResourceTest {

	@BeforeClass
	public static void beforeClass() throws Exception {
		addPerRequestResource(ExampleResource.class);
	}

	Client client;

	@Before
	public void setUp() {
		client = ClientBuilder.newClient();
	}

	@After
	public void tearDown() {
		client.close();
	}

	Builder request(String path) {
		WebTarget target = client.target(TestPortProvider
				.generateURL("/example" + path));
		return target.request();
	}

	@Test
	public void index() throws Exception {
		try (CloseableResponse response = of(request("").get())) {
			assertEquals(200, response.getStatus());
			Example exp = response.readEntity(Example.class);
			assertEquals("Hello", exp.getName());
		}
	}

	@Test
	public void name() throws Exception {
		try (CloseableResponse response = of(request("/Joe").get())) {
			assertEquals(200, response.getStatus());
			Example exp = response.readEntity(Example.class);
			assertEquals(33, exp.getId());
			assertEquals("Joe", exp.getName());
		}
	}

}
